package xyz.tbvns.ui.Elements;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.g3d.Model;
import com.badlogic.gdx.graphics.g3d.ModelInstance;
import imgui.ImGui;
import imgui.extension.imguizmo.ImGuizmo;
import imgui.flag.ImGuiWindowFlags;
import imgui.type.ImInt;
import imgui.type.ImString;
import xyz.tbvns.Editor.ModelsManager;
import xyz.tbvns.LevelInfo;
import xyz.tbvns.Main;
import xyz.tbvns.Models.GDInstance;
import xyz.tbvns.Models.GDModel;
import xyz.tbvns.ui.Element;

import java.util.HashMap;
import java.util.Random;

public class Timeline implements Element {

    @Override
    public void render() {
        ImGui.begin("TimeMenu", ImGuiWindowFlags.NoDecoration | ImGuiWindowFlags.NoMove | ImGuiWindowFlags.NoBringToFrontOnFocus);
        float[] pos = new float[]{Main.getCamera().position.x / (LevelInfo.getLevel().getMaxPos() / 30) * 100};
        ImGui.pushItemWidth(ImGui.getWindowWidth() - 16);
        ImGui.sliderFloat("##Slider%", pos, 0, 100);
        Main.getCamera().position.set((pos[0] / 100) * (LevelInfo.getLevel().getMaxPos() / 30), Main.getCamera().position.y, Main.getCamera().position.z);
        ImGui.setWindowSize(Gdx.graphics.getWidth(), 201);
        ImGui.setWindowPos(0, Gdx.graphics.getHeight() - 201);

        ImGui.pushItemWidth(200);
        ImGui.labelText("##", "Name:");
        ImGui.sameLine();
        ImGui.pushItemWidth(100);
        ImGui.labelText("##", "FPS:");
        ImGui.sameLine();
        ImGui.pushItemWidth(100);
        ImGui.labelText("##", "Frame skip:");
        ImGui.sameLine();
        ImGui.pushItemWidth(100);
        ImGui.labelText("##", "Start frame:");

        for (ModelInstance model : ModelsManager.getLoadedModels()) {
            GDInstance instance = ((GDInstance) model.userData);
            ImString name = new ImString(instance.getName());
            ImGui.pushItemWidth(200);
            ImGui.inputText("##name" + instance.getId(), name);
            instance.setName(name.get());

            ImGui.sameLine();
            ImInt fps = new ImInt(instance.getFps());
            ImGui.pushItemWidth(100);
            ImGui.inputInt("##fps" + instance.getId(), fps);
            instance.setFps(fps.get());

            if (instance.isAnimation()) {
                ImGui.sameLine();
                ImInt skipFrame = new ImInt(instance.getFrameSkip());
                ImGui.pushItemWidth(100);
                ImGui.inputInt("##frameSkip" + instance.getId(), skipFrame);
                instance.setFrameSkip(skipFrame.get());

                ImGui.sameLine();
                ImInt startFrame = new ImInt(instance.getStart());
                ImGui.pushItemWidth(100);
                ImGui.inputInt("##startFrame" + instance.getId(), startFrame);
                instance.setStart(startFrame.get());

                ImGui.sameLine();
                if (ImGui.checkbox("Expand", instance.isExpanded())) {
                    instance.setExpanded(!instance.isExpanded());
                }
            }
        }

        if (ModelsManager.getLoadedModels().size() == 0) {
            ImGui.text("No models loaded.\nTry adding some.");
        }

        ImGui.end();
    }
}
